;; blue-steel/theme.jl
;; $Id$

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; The images and design of this theme are from Daniel Erat's
;; BlueSteel theme for Enlightenment

(let*
    ((title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (- (min (max (/ w-width 2) 100) w-width) 30)))))

     (menu-i (list (make-image "close_bg.png")
		   (make-image "close_fg.png") nil
		   (make-image "close_cl.png")))
     ;; 16x20
       
     ;; 61x20
     (title-i (list (make-image "default_title_bg.png")
		    (make-image "default_title_fg.png")))
       
     ;; 85x20
     (toprighttrim-i (list (make-image "toprighttrim_bg.png")
			   (make-image "toprighttrim_fg.png")))
       
     ;; 10x35
     (lefttrim-i (list (make-image "lefttrim_bg.png")
		       (make-image "lefttrim_fg.png")))
       
     ;; 35x16
     (top-i (list (make-image "default_top_bg.png")
		  (make-image "default_top_fg.png")))
       
     ;; 12x16
     (max-i (list (make-image "maximize_bg.png")
		  (make-image "maximize_fg.png") nil
		  (make-image "maximize_cl.png")))
       
     ;; 12x16
     (min-i (list (make-image "minimize_bg.png")
		  (make-image "minimize_fg.png") nil
		  (make-image "minimize_cl.png")))
       
     ;; 14x16
     (close-i (list (make-image "stick_bg.png")
		    (make-image "stick_fg.png") nil
		    (make-image "stick_cl.png")))
       
     ;; 6x81
     (right-i (list (make-image "right_bg.png") (make-image "right_fg.png")))
       
     ;; 6x76
     (left-i (list (make-image "left_bg.png") (make-image "left_fg.png")))
       
     ;; 201x6
     (bottom-i (list (make-image "default_bottom_bg.png")
		     (make-image "default_bottom_fg.png")))
       
     ;; 45x10
     (bottomtrim-i (list (make-image "default_bottomtrim_bg.png")
			 (make-image "default_bottomtrim_fg.png")))
       
     ;; 10x35
     (righttrim-i (list (make-image "righttrim_bg.png")
			(make-image "righttrim_fg.png")))
       
     ;; 11x6
     (bottomresize-i (list (make-image "bottomresize_bg.png")
			   (make-image "bottomresize_fg.png")))
       
     ;; 213x6
     (trans-top-i (list (set-image-border
			 (make-image "verysmall_top_bg.png") 10 10 0 0)
			(set-image-border
			 (make-image "verysmall_top_fg.png") 10 10 0 0)))
     (trans-bottom-i (list (set-image-border
			    (make-image "fixed_bottom_bg.png") 10 10 0 0)
			   (set-image-border
			    (make-image "fixed_bottom_fg.png") 10 10 0 0)))

     (frame `(((background . ,menu-i)
	       (left-edge . -10)
	       (top-edge . -20)
	       (class . menu-button))
	      ((background . ,title-i)
	       (left-edge . 6)
	       (top-edge . -20)
	       (width . ,title-width)
	       (foreground . "white")
	       (text . ,window-name)
	       (y-justify . 3)
	       (x-justify . center)
	       (class . title))
	      ((background . ,toprighttrim-i)
	       (left-edge . ,(lambda (w) (+ 6 (title-width w))))
	       (top-edge . -20)
	       (class . title))
	      ((background . ,top-i)
	       (left-edge . ,(lambda (w) (+ 6 (title-width w) 85)))
	       (top-edge . -16)
	       (right-edge . 32)
	       (class . title))
	      ((background . ,min-i)
	       (right-edge . 20)
	       (top-edge . -16)
	       (class . iconify-button))
	      ((background . ,max-i)
	       (right-edge . 8)
	       (top-edge . -16)
	       (class . maximize-button))
	      ((background . ,close-i)
	       (right-edge . -6)
	       (top-edge . -16)
	       (class . close-button))
	      ((background . ,lefttrim-i)
	       (left-edge . -10)
	       (top-edge . 0)
	       (class . left-border))
	      ((background . ,left-i)
	       (left-edge . -6)
	       (top-edge . 35)
	       (bottom-edge . -6)
	       (class . left-border))
	      ((background . ,bottomresize-i)
	       (left-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))
	      ((background . ,bottom-i)
	       (left-edge . 5)
	       (right-edge . 29)
	       (bottom-edge . -6)
	       (class . bottom-border))
	      ((background . ,bottomtrim-i)
	       (right-edge . -10)
	       (bottom-edge . -10)
	       (class . bottom-right-corner))
	      ((background . ,righttrim-i)
	       (right-edge . -10)
	       (bottom-edge . -2)
	       (class . bottom-right-corner))
	      ((background . ,right-i)
	       (right-edge . -6)
	       (top-edge . 0)
	       (bottom-edge . 29)
	       (class . right-border))))

     (shaped-frame `(((background . ,menu-i)
		      (left-edge . -10)
		      (top-edge . -20)
		      (class . menu-button))
		     ((background . ,title-i)
		      (left-edge . 6)
		      (top-edge . -20)
		      (width . ,title-width)
		      (foreground . "white")
		      (text . ,window-name)
		      (y-justify . 3)
		      (x-justify . center)
		      (class . title))
		     ((background . ,toprighttrim-i)
		      (left-edge . ,(lambda (w) (+ 6 (title-width w))))
		      (top-edge . -20)
		      (class . title))
		     ((background . ,top-i)
		      (left-edge . ,(lambda (w) (+ 6 (title-width w) 85)))
		      (top-edge . -16)
		      (right-edge . 32)
		      (class . title))
		     ((background . ,min-i)
		      (right-edge . 20)
		      (top-edge . -16)
		      (class . iconify-button))
		     ((background . ,max-i)
		      (right-edge . 8)
		      (top-edge . -16)
		      (class . maximize-button))
		     ((background . ,close-i)
		      (right-edge . -6)
		      (top-edge . -16)
		      (class . close-button))))

     (transient-frame `(((background . ,trans-top-i)
			 (left-edge . -6)
			 (right-edge . -6)
			 (top-edge . -6)
			 (class . title))
			((background . ,right-i)
			 (right-edge . -6)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . right-border))
			((background . ,left-i)
			 (left-edge . -6)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . left-border))
			((background . ,trans-bottom-i)
			 (left-edge . -6)
			 (right-edge . -6)
			 (bottom-edge . -6)
			 (class . bottom-border))))

     (shaped-transient-frame `(((background . ,trans-top-i)
				(left-edge . -6)
				(right-edge . -6)
				(top-edge . -6)
				(class . title)))))

  (mapc (lambda (i)
	  (image-put i 'tiled t)) top-i)

  (add-frame-style 'blue-steel
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((shaped) shaped-frame)
		       ((transient) transient-frame)
		       ((shaped-transient) shaped-transient-frame)))))
